package cn.sxt.dz;

import java.awt.Color;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Rectangle;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.net.URL;

import javax.imageio.ImageIO;




public class MyPlaneGame extends Frame{

	private static final long serialVersionUID = 1L;
	Image bj = GameUtil.getImage("Images/bj.png");
	Image myPlane = GameUtil.getImage("Images/plane.jpg");
	Image enemyPlane = GameUtil.getImage("Images/plane5.png");//صл
	
	Plane myPlane0 = new Plane(myPlane,600,600);
	Plane enrmyPlane = new Plane(enemyPlane,300,0);
	
	Explode bao;
	/**
	 * ڴлͼƬ
	 */
	@Override
	public void paint(Graphics g) {//g൱һֱʣᱻԶ
		Color c = g.getColor();
		Font font = g.getFont();
		super.paint(g);
		g.drawImage(bj, 0, 0, null);
		myPlane0.drawSelf(g);//ɻ
		enrmyPlane.drawEnemyPlany(g);//л
		
		addKeyListener(new KeyMonitor());//Ӽ̵ļ
			
		g.setColor(Color.red);
		g.setFont(new Font("", Font.BOLD, 50));
		g.drawString("", 650, 100);//ַ
		
		boolean peng = enemyPlane.getRect().intersects(myPlane0.getRect());
		
		g.setColor(c);
		g.setFont(font);
	}
	
	//Ƿػ
	class PaintThread extends Thread{
		@Override
		public void run() {
			while(true) {
				repaint();//ػ				
				try {     //ֵ쳣
					Thread.sleep(40);//1s=1000ms
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
		}
	}
	
	
	public void launchFrame() {
		this.setTitle("ѧѧԱ--ŷ----ɻսСϷ");
		this.setVisible(true);//
		this.setSize(960, 800);//ôڵĴС
		this.setLocation(200, 100);//ôڵλ
		
		//ӼĴ룬رմʱ
		this.addWindowListener(new WindowAdapter() {//ڲ
			@Override
			public void windowClosing(WindowEvent e) {//رմʱ
				System.exit(0);//0ʾΪ쳣
			}
		});	
		
		new PaintThread().start();//ػڵ߳
	}
	
	
	
	//̼ڲ
	class KeyMonitor extends KeyAdapter{

		@Override
		public void keyPressed(KeyEvent e) {
			myPlane0.addDirection(e);
			
		}

		@Override
		public void keyReleased(KeyEvent e) {
			myPlane0.minusDirection(e);
		}
		
	}	
	
	/**
	   * 
	 * @param args
	 */	
	public static void main(String[] args) {
		MyPlaneGame f = new MyPlaneGame();
		f.launchFrame();
		
	}


	/**
	 * ˫˸
	 */
	private Image offScreenImage = null;
	 
	public void update(Graphics g) {
	    if(offScreenImage == null)
	        offScreenImage = this.createImage(960,800);//ϷڵĿȺ͸߶
	     
	    Graphics gOff = offScreenImage.getGraphics();
	    paint(gOff);
	    g.drawImage(offScreenImage, 0, 0, null);
	}  
}


/**
   * ɻ
 * @author Mr_xi
 *
 */
class Plane extends GameObject{
	boolean left,right,up,down;
	int speed = 3;
	boolean live = true;
	public void drawEnemyPlany(Graphics g) {
		g.drawImage(img, (int)x, (int)y, null);
		y+=speed;
	}
	
	public void drawSelf(Graphics g) {
		if(live) {
			g.drawImage(img, (int)x, (int)y, null);
			if(left) {
				x-=speed;
			}
			if(right) {
				x+=speed;
			}
			if(up) {
				y-=speed;
			}
			if(down) {
				y+=speed;
			}
		}else {
			
		}
		
	}
	
	public Plane(Image img,double x,double y){
		this.img = img;
		this.x = x;
		this.y = y;
		this.speed = 3;
		this.width = img.getWidth(null);
		this.height = img.getHeight(null);
	}
	
	//ĳӦķ
	public void addDirection(KeyEvent e) {
		switch(e.getKeyCode()) {
		case KeyEvent.VK_LEFT:
			left = true;
			break;
		case KeyEvent.VK_RIGHT:
			right = true;
			break;
		case KeyEvent.VK_UP:
			up = true;
			break;
		case KeyEvent.VK_DOWN:
			down = true;
			break;			
		}
	}
	//ɿĳȡӦķ
	public void minusDirection(KeyEvent e) {
		switch(e.getKeyCode()) {
		case KeyEvent.VK_LEFT:
			left = false;
			break;
		case KeyEvent.VK_RIGHT:
			right = false;
			break;
		case KeyEvent.VK_UP:
			up = false;
			break;
		case KeyEvent.VK_DOWN:
			down = false;
			break;			
		}
	}
}
/**
 * Ϸĸ
 * @author ŷ
 *
 */
class GameObject {
	Image img;
	double x,y;
	int speed;
	int width,height;
	
	public void drawSelf(Graphics g) {
		g.drawImage(img, (int)x, (int)y, null);
	}

	public GameObject(Image img, double x, double y, int speed, int width, int height) {
		super();
		this.img = img;
		this.x = x;
		this.y = y;
		this.speed = speed;
		this.width = width;
		this.height = height;
	}
	//һ
	public GameObject(Image img, double x, double y) {
		super();
		this.img = img;
		this.x = x;
		this.y = y;
	}
	
	//һչ
	public GameObject() {
	}
	/**
	 * ڵľΣںײ
	 */
	public Rectangle getRect(){
		return new Rectangle((int)x, (int)y, width, height);
	}
	
	
	
	
}
/*
 * ը
 */
class Explode {
    double x,y;
    static Image[] imgs = new Image[16];
    static {
        for(int i=0;i<16;i++){
            imgs[i] = GameUtil.getImage("images/explode/e"+(i+1)+".gif");
            imgs[i].getWidth(null);
        }
    }
     
    int count;
     
    public void draw(Graphics g){
        if(count<=15){
            g.drawImage(imgs[count], (int)x, (int)y, null);
            count++;
        }
    }
     
    public Explode(double x,double y){
        this.x = x;
        this.y = y;
    }
}



/**
 * ǼͼƬ
 * @author Mr_xi
 *
 */
class GameUtil {
    // ý˽л
    private GameUtil() {
     
    } 
 
    public static Image getImage(String path) {
        BufferedImage bi = null;
        try {
            URL u = GameUtil.class.getClassLoader().getResource(path);
            bi = ImageIO.read(u);
        } catch (IOException e) {
            e.printStackTrace();
        }
        return bi;
    }
}





